Package | Class | Tree | Index
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.jnlp
Interface JNLPRandomAccessFile

public interface JNLPRandomAccessFile
extends java.io.DataInput, java.io.DataOutput

Instances of this class support both reading and writing to a random access file. A random access file behaves like a large array of bytes stored in the file system. There is a kind of cursor, or index into the implied array, called the file pointer; input operations read bytes starting at the file pointer and advance the file pointer past the bytes read. If the random access file is created in read/write mode, then output operations are also available; output operations write bytes starting at the file pointer and advance the file pointer past the bytes written. Output operations that write past the current end of the implied array cause the array to be extended. The file pointer can be read by the `getFilePointer` method and set by the `seek` method.

It is generally true of all the reading routines in this class that if end-of-file is reached before the desired number of bytes has been read, an `EOFException` (which is a kind of `IOException`) is thrown. If any byte cannot be read for any reason other than end-of-file, an `IOException` other than `EOFException` is thrown. In particular, an `IOException` may be thrown if the stream has been closed.

Implementations are encouraged to enforce a maximum amount of data that may be written to a file.

Version:
  1.0

Method Summary
`void` | `close()` Closes this random access file stream and releases any system resources associated with the stream.
`long` | `getFilePointer()` Returns the current offset in this file.
`long` | `length()` Returns the length of this file.
`int` | `read()` Reads a byte of data from this file.
`int` | `read(byte[] b)` Reads up to `b.length` bytes of data from this file into an array of bytes.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from this file into an array of bytes.
`boolean` | `readBoolean()` Reads a `boolean` from this file.
`byte` | `readByte()` Reads a signed eight-bit value from this file.
`char` | `readChar()` Reads a Unicode character from this file.
`double` | `readDouble()` Reads a `double` from this file.
`float` | `readFloat()` Reads a `float` from this file.
`void` | `readFully(byte[] b)` Reads `b.length` bytes from this file into the byte array, starting at the current file pointer.
`void` | `readFully(byte[] b, int off, int len)` Reads exactly `len` bytes from this file into the byte array, starting at the current file pointer.
`int` | `readInt()` Reads a signed 32-bit integer from this file.
`java.lang.String` | `readLine()` Reads the next line of text from this file.
`long` | `readLong()` Reads a signed 64-bit integer from this file.
`short` | `readShort()` Reads a signed 16-bit number from this file.
`int` | `readUnsignedByte()` Reads an unsigned eight-bit number from this file.
`int` | `readUnsignedShort()` Reads an unsigned 16-bit number from this file.
`java.lang.String` | `readUTF()` Reads in a string from this file.
`void` | `seek(long pos)` Sets the file-pointer offset, measured from the beginning of this file, at which the next read or write occurs.
`void` | `setLength(long newLength)` Sets the length of this file.
`int` | `skipBytes(int n)` Attempts to skip over `n` bytes of input discarding the skipped bytes.
`void` | `write(byte[] b)` Writes `b.length` bytes from the specified byte array to this file, starting at the current file pointer.
`void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this file.
`void` | `write(int b)` Writes the specified byte to this file.
`void` | `writeBoolean(boolean v)` Writes a `boolean` to the file as a one-byte value.
`void` | `writeByte(int v)` Writes a `byte` to the file as a one-byte value.
`void` | `writeBytes(java.lang.String s)` Writes the string to the file as a sequence of bytes.
`void` | `writeChar(int v)` Writes a `char` to the file as a two-byte value, high byte first.
`void` | `writeChars(java.lang.String s)` Writes a string to the file as a sequence of characters.
`void` | `writeDouble(double v)` Converts the double argument to a `long` using the `doubleToLongBits` method in class `Double`, and then writes that `long` value to the file as an eight-byte quantity, high byte first.
`void` | `writeFloat(float v)` Converts the float argument to an `int` using the `floatToIntBits` method in class `Float`, and then writes that `int` value to the file as a four-byte quantity, high byte first.
`void` | `writeInt(int v)` Writes an `int` to the file as four bytes, high byte first.
`void` | `writeLong(long v)` Writes a `long` to the file as eight bytes, high byte first.
`void` | `writeShort(int v)` Writes a `short` to the file as two bytes, high byte first.
`void` | `writeUTF(java.lang.String str)` Writes a string to the file using UTF-8 encoding in a machine-independent manner.

Method Detail

### close

    public void close()
               throws java.io.IOException

  Closes this random access file stream and releases any system resources associated with the stream. A closed random access file cannot perform input or output operations and cannot be reopened.
  Throws:
    java.io.IOException - if an I/O error occurs.

### length

    public long length()
                throws java.io.IOException

  Returns the length of this file.
  Returns:
    the length of this file, measured in bytes.
  Throws:
    java.io.IOException - if an I/O error occurs.

### getFilePointer

    public long getFilePointer()
                        throws java.io.IOException

  Returns the current offset in this file.
  Returns:
    the offset from the beginning of the file, in bytes, at which the next read or write occurs.
  Throws:
    java.io.IOException - if an I/O error occurs.

### read

    public int read()
             throws java.io.IOException

  Reads a byte of data from this file. The byte is returned as an integer in the range 0 to 255 (`0x00-0x0ff`). This method blocks if no input is yet available.

  Although `JNLPRandomAccessFile` is not a subclass of `InputStream`, this method behaves in exactly the same way as the read method of `InputStream`.

  Returns:
    the next byte of data, or `-1` if the end of the file has been reached.
  Throws:
    java.io.IOException - if an I/O error occurs. Not thrown if end-of-file has been reached.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws java.io.IOException

  Reads up to `len` bytes of data from this file into an array of bytes. This method blocks until at least one byte of input is available.

  Although `JNLPRandomAccessFile` is not a subclass of `InputStream`, this method behaves in the exactly the same way as the read(byte[], int, int) method of `InputStream`.

  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the maximum number of bytes read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the file has been reached.
  Throws:
    java.io.IOException - if an I/O error occurs.

### read

    public int read(byte[] b)
             throws java.io.IOException

  Reads up to `b.length` bytes of data from this file into an array of bytes. This method blocks until at least one byte of input is available.

  Although `JNLPRandomAccessFile` is not a subclass of `InputStream`, this method behaves in the exactly the same way as the read(byte[]) method of `InputStream`.

  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of this file has been reached.
  Throws:
    java.io.IOException - if an I/O error occurs.

### readFully

    public void readFully(byte[] b)
                   throws java.io.IOException

  Reads `b.length` bytes from this file into the byte array, starting at the current file pointer. This method reads repeatedly from the file until the requested number of bytes are read. This method blocks until the requested number of bytes are read, the end of the stream is detected, or an exception is thrown.
  Specified by:
    readFully in interface java.io.DataInput
  Parameters:
    `b` - the buffer into which the data is read.
  Throws:
    EOFException - if this file reaches the end before reading all the bytes.
    java.io.IOException - if an I/O error occurs.

### readFully

    public void readFully(byte[] b,
                          int off,
                          int len)
                   throws java.io.IOException

  Reads exactly `len` bytes from this file into the byte array, starting at the current file pointer. This method reads repeatedly from the file until the requested number of bytes are read. This method blocks until the requested number of bytes are read, the end of the stream is detected, or an exception is thrown.
  Specified by:
    readFully in interface java.io.DataInput
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the number of bytes to read.
  Throws:
    EOFException - if this file reaches the end before reading all the bytes.
    java.io.IOException - if an I/O error occurs.

### skipBytes

    public int skipBytes(int n)
                  throws java.io.IOException

  Attempts to skip over `n` bytes of input discarding the skipped bytes.

  This method may skip over some smaller number of bytes, possibly zero. This may result from any of a number of conditions; reaching end of file before `n` bytes have been skipped is only one possibility. This method never throws an `EOFException`. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.

  Specified by:
    skipBytes in interface java.io.DataInput
  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    java.io.IOException - if an I/O error occurs.

### readBoolean

    public boolean readBoolean()
                        throws java.io.IOException

  Reads a `boolean` from this file. This method reads a single byte from the file, starting at the current file pointer. A value of `0` represents `false`. Any other value represents `true`. This method blocks until the byte is read, the end of the stream is detected, or an exception is thrown.
  Specified by:
    readBoolean in interface java.io.DataInput
  Returns:
    the `boolean` value read.
  Throws:
    EOFException - if this file has reached the end.
    java.io.IOException - if an I/O error occurs.

### readByte

    public byte readByte()
                  throws java.io.IOException

  Reads a signed eight-bit value from this file. This method reads a byte from the file, starting from the current file pointer. If the byte read is `b`, where `0 <= b <= 255`, then the result is:

  >          (byte)(b)

  This method blocks until the byte is read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readByte in interface java.io.DataInput
  Returns:
    the next byte of this file as a signed eight-bit `byte`.
  Throws:
    EOFException - if this file has reached the end.
    java.io.IOException - if an I/O error occurs.

### readUnsignedByte

    public int readUnsignedByte()
                         throws java.io.IOException

  Reads an unsigned eight-bit number from this file. This method reads a byte from this file, starting at the current file pointer, and returns that byte.

  This method blocks until the byte is read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readUnsignedByte in interface java.io.DataInput
  Returns:
    the next byte of this file, interpreted as an unsigned eight-bit number.
  Throws:
    EOFException - if this file has reached the end.
    java.io.IOException - if an I/O error occurs.

### readShort

    public short readShort()
                    throws java.io.IOException

  Reads a signed 16-bit number from this file. The method reads two bytes from this file, starting at the current file pointer. If the two bytes read, in order, are `b1` and `b2`, where each of the two values is between `0` and `255`, inclusive, then the result is equal to:

  >          (short)((b1 << 8) | b2)

  This method blocks until the two bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readShort in interface java.io.DataInput
  Returns:
    the next two bytes of this file, interpreted as a signed 16-bit number.
  Throws:
    EOFException - if this file reaches the end before reading two bytes.
    java.io.IOException - if an I/O error occurs.

### readUnsignedShort

    public int readUnsignedShort()
                          throws java.io.IOException

  Reads an unsigned 16-bit number from this file. This method reads two bytes from the file, starting at the current file pointer. If the bytes read, in order, are `b1` and `b2`, where `0 <= b1, b2 <= 255`, then the result is equal to:

  >          (b1 << 8) | b2

  This method blocks until the two bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readUnsignedShort in interface java.io.DataInput
  Returns:
    the next two bytes of this file, interpreted as an unsigned 16-bit integer.
  Throws:
    EOFException - if this file reaches the end before reading two bytes.
    java.io.IOException - if an I/O error occurs.

### readChar

    public char readChar()
                  throws java.io.IOException

  Reads a Unicode character from this file. This method reads two bytes from the file, starting at the current file pointer. If the bytes read, in order, are `b1` and `b2`, where `0 <= b1, b2 <= 255`, then the result is equal to:

  >          (char)((b1 << 8) | b2)

  This method blocks until the two bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readChar in interface java.io.DataInput
  Returns:
    the next two bytes of this file as a Unicode character.
  Throws:
    EOFException - if this file reaches the end before reading two bytes.
    java.io.IOException - if an I/O error occurs.

### readInt

    public int readInt()
                throws java.io.IOException

  Reads a signed 32-bit integer from this file. This method reads 4 bytes from the file, starting at the current file pointer. If the bytes read, in order, are `b1`, `b2`, `b3`, and `b4`, where `0 <= b1, b2, b3, b4 <= 255`, then the result is equal to:

  >          (b1 << 24) | (b2 << 16) + (b3 << 8) + b4

  This method blocks until the four bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readInt in interface java.io.DataInput
  Returns:
    the next four bytes of this file, interpreted as an `int`.
  Throws:
    EOFException - if this file reaches the end before reading four bytes.
    java.io.IOException - if an I/O error occurs.

### readLong

    public long readLong()
                  throws java.io.IOException

  Reads a signed 64-bit integer from this file. This method reads eight bytes from the file, starting at the current file pointer. If the bytes read, in order, are `b1`, `b2`, `b3`, `b4`, `b5`, `b6`, `b7`, and `b8,` where:

  >          0 <= b1, b2, b3, b4, b5, b6, b7, b8 <=255,

  then the result is equal to:

  >          ((long)b1 << 56) + ((long)b2 << 48)
  >          + ((long)b3 << 40) + ((long)b4 << 32)
  >          + ((long)b5 << 24) + ((long)b6 << 16)
  >          + ((long)b7 << 8) + b8

  This method blocks until the eight bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readLong in interface java.io.DataInput
  Returns:
    the next eight bytes of this file, interpreted as a `long`.
  Throws:
    EOFException - if this file reaches the end before reading eight bytes.
    java.io.IOException - if an I/O error occurs.

### readFloat

    public float readFloat()
                    throws java.io.IOException

  Reads a `float` from this file. This method reads an `int` value, starting at the current file pointer, as if by the `readInt` method and then converts that `int` to a `float` using the `intBitsToFloat` method in class `Float`.

  This method blocks until the four bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readFloat in interface java.io.DataInput
  Returns:
    the next four bytes of this file, interpreted as a `float`.
  Throws:
    EOFException - if this file reaches the end before reading four bytes.
    java.io.IOException - if an I/O error occurs.
  See Also:
    `readInt()`

### readDouble

    public double readDouble()
                      throws java.io.IOException

  Reads a `double` from this file. This method reads a `long` value, starting at the current file pointer, as if by the `readLong` method and then converts that `long` to a `double` using the `longBitsToDouble` method in class `Double`.

  This method blocks until the eight bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readDouble in interface java.io.DataInput
  Returns:
    the next eight bytes of this file, interpreted as a `double`.
  Throws:
    EOFException - if this file reaches the end before reading eight bytes.
    java.io.IOException - if an I/O error occurs.
  See Also:
    `readLong()`

### readLine

    public java.lang.String readLine()
                              throws java.io.IOException

  Reads the next line of text from this file. This method successively reads bytes from the file, starting at the current file pointer, until it reaches a line terminator or the end of the file. Each byte is converted into a character by taking the byte's value for the lower eight bits of the character and setting the high eight bits of the character to zero. This method does not, therefore, support the full Unicode character set.

  A line of text is terminated by a carriage-return character (`'\r'`), a newline character (`'\n'`), a carriage-return character immediately followed by a newline character, or the end of the file. Line-terminating characters are discarded and are not included as part of the string returned.

  This method blocks until a newline character is read, a carriage return and the byte following it are read (to see if it is a newline), the end of the file is reached, or an exception is thrown.

  Specified by:
    readLine in interface java.io.DataInput
  Returns:
    the next line of text from this file, or null if end of file is encountered before even one byte is read.
  Throws:
    java.io.IOException - if an I/O error occurs.

### readUTF

    public java.lang.String readUTF()
                             throws java.io.IOException

  Reads in a string from this file. The string has been encoded using a modified UTF-8 format.

  The first two bytes are read, starting from the current file pointer, as if by `readUnsignedShort`. This value gives the number of following bytes that are in the encoded string, not the length of the resulting string. The following bytes are then interpreted as bytes encoding characters in the UTF-8 format and are converted into characters.

  This method blocks until all the bytes are read, the end of the stream is detected, or an exception is thrown.

  Specified by:
    readUTF in interface java.io.DataInput
  Returns:
    a Unicode string.
  Throws:
    EOFException - if this file reaches the end before reading all the bytes.
    java.io.IOException - if an I/O error occurs.
    UTFDataFormatException - if the bytes do not represent valid UTF-8 encoding of a Unicode string.
  See Also:
    `readUnsignedShort()`

### seek

    public void seek(long pos)
              throws java.io.IOException

  Sets the file-pointer offset, measured from the beginning of this file, at which the next read or write occurs. The offset may be set beyond the end of the file. Setting the offset beyond the end of the file does not change the file length. The file length will change only by writing after the offset has been set beyond the end of the file.
  Parameters:
    `pos` - the offset position, measured in bytes from the beginning of the file, at which to set the file pointer.
  Throws:
    java.io.IOException - if `pos` is less than `0` or if an I/O error occurs.

### setLength

    public void setLength(long newLength)
                   throws java.io.IOException

  Sets the length of this file.

  If the present length of the file as returned by the `length` method is greater than the `newLength` argument then the file will be truncated. In this case, if the file offset as returned by the `getFilePointer` method is greater then `newLength` then after this method returns the offset will be equal to `newLength`.

  If the present length of the file as returned by the `length` method is smaller than the `newLength` argument then the file will be extended. In this case, the contents of the extended portion of the file are not defined.

  Parameters:
    `newLength` - The desired length of the file
  Throws:
    java.io.IOException - If an I/O error occurs

### write

    public void write(int b)
               throws java.io.IOException

  Writes the specified byte to this file. The write starts at the current file pointer.
  Specified by:
    write in interface java.io.DataOutput
  Parameters:
    `b` - the `byte` to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### write

    public void write(byte[] b)
               throws java.io.IOException

  Writes `b.length` bytes from the specified byte array to this file, starting at the current file pointer.
  Specified by:
    write in interface java.io.DataOutput
  Parameters:
    `b` - the data.
  Throws:
    java.io.IOException - if an I/O error occurs.

### write

    public void write(byte[] b,
                      int off,
                      int len)
               throws java.io.IOException

  Writes `len` bytes from the specified byte array starting at offset `off` to this file.
  Specified by:
    write in interface java.io.DataOutput
  Parameters:
    `b` - the data.
    `off` - the start offset in the data.
    `len` - the number of bytes to write.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeBoolean

    public void writeBoolean(boolean v)
                      throws java.io.IOException

  Writes a `boolean` to the file as a one-byte value. The value `true` is written out as the value `(byte)1`; the value `false` is written out as the value `(byte)0`. The write starts at the current position of the file pointer.
  Specified by:
    writeBoolean in interface java.io.DataOutput
  Parameters:
    `v` - a `boolean` value to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeByte

    public void writeByte(int v)
                   throws java.io.IOException

  Writes a `byte` to the file as a one-byte value. The write starts at the current position of the file pointer.
  Specified by:
    writeByte in interface java.io.DataOutput
  Parameters:
    `v` - a `byte` value to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeShort

    public void writeShort(int v)
                    throws java.io.IOException

  Writes a `short` to the file as two bytes, high byte first. The write starts at the current position of the file pointer.
  Specified by:
    writeShort in interface java.io.DataOutput
  Parameters:
    `v` - a `short` to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeChar

    public void writeChar(int v)
                   throws java.io.IOException

  Writes a `char` to the file as a two-byte value, high byte first. The write starts at the current position of the file pointer.
  Specified by:
    writeChar in interface java.io.DataOutput
  Parameters:
    `v` - a `char` value to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeInt

    public void writeInt(int v)
                  throws java.io.IOException

  Writes an `int` to the file as four bytes, high byte first. The write starts at the current position of the file pointer.
  Specified by:
    writeInt in interface java.io.DataOutput
  Parameters:
    `v` - an `int` to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeLong

    public void writeLong(long v)
                   throws java.io.IOException

  Writes a `long` to the file as eight bytes, high byte first. The write starts at the current position of the file pointer.
  Specified by:
    writeLong in interface java.io.DataOutput
  Parameters:
    `v` - a `long` to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeFloat

    public void writeFloat(float v)
                    throws java.io.IOException

  Converts the float argument to an `int` using the `floatToIntBits` method in class `Float`, and then writes that `int` value to the file as a four-byte quantity, high byte first. The write starts at the current position of the file pointer.
  Specified by:
    writeFloat in interface java.io.DataOutput
  Parameters:
    `v` - a `float` value to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeDouble

    public void writeDouble(double v)
                     throws java.io.IOException

  Converts the double argument to a `long` using the `doubleToLongBits` method in class `Double`, and then writes that `long` value to the file as an eight-byte quantity, high byte first. The write starts at the current position of the file pointer.
  Specified by:
    writeDouble in interface java.io.DataOutput
  Parameters:
    `v` - a `double` value to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeBytes

    public void writeBytes(java.lang.String s)
                    throws java.io.IOException

  Writes the string to the file as a sequence of bytes. Each character in the string is written out, in sequence, by discarding its high eight bits. The write starts at the current position of the file pointer.
  Specified by:
    writeBytes in interface java.io.DataOutput
  Parameters:
    `s` - a string of bytes to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

### writeChars

    public void writeChars(java.lang.String s)
                    throws java.io.IOException

  Writes a string to the file as a sequence of characters. Each character is written to the data output stream as if by the `writeChar` method. The write starts at the current position of the file pointer.
  Specified by:
    writeChars in interface java.io.DataOutput
  Parameters:
    `s` - a `String` value to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.
  See Also:
    `writeChar(int)`

### writeUTF

    public void writeUTF(java.lang.String str)
                  throws java.io.IOException

  Writes a string to the file using UTF-8 encoding in a machine-independent manner.

  First, two bytes are written to the file, starting at the current file pointer, as if by the `writeShort` method giving the number of bytes to follow. This value is the number of bytes actually written out, not the length of the string. Following the length, each character of the string is output, in sequence, using the UTF-8 encoding for each character.

  Specified by:
    writeUTF in interface java.io.DataOutput
  Parameters:
    `str` - a string to be written.
  Throws:
    java.io.IOException - if an I/O error occurs.

Package | Class | Tree | Index
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2001-2002 Sun Microsystems, Inc. All Rights Reserved